/*
  [
  light_direction, specular, shininess
  ambient,
  diffuse_front, diffuse_back,
  //specular, shininess,
  grid_front, grid_back,
  pline_x, pline_y
  ]
*/

var _ambient = [0.03, 0.03, 0.03];


var _colors =
    [
        // light
        [
            // light_direction, specular, shininess
            [0.7, 0.0, 0.7], [0.0, 0.0, 0.0], 0.0,
            _ambient,
            [0.95, 0.95, 0.95], [0.95, 0.95, 0.95],
            [0.6, 0.6, 0.6], [0.6, 0.6, 0.6],
            //[46.0/255, 124.0/255, 138.0/255],
            //[46.0/255, 76.0/255, 138.0/255]
            [100.0/255, 0.0/255, 0.0/255],
            [100.0/255, 0.0/255, 0.0/255]
        ],
        // warm
        [
            // light_direction, specular, shininess
            [0.7, 0.0, 0.7], [0.8, 0.8, 0.8], 0.2,
            _ambient,
            [0.7, 0.35, 0.7], [1.0, 0.5, 0.0],
            //specular, shininess,
            [0.15, 0.15, 0.15], [0.15, 0.15, 0.15],
            [1.0, 1.0, 1.0], [0.5, 0.5, 0.5]
        ],
        // cool
        [
            // light_direction, specular, shininess
            [0.7, 0.0, 0.7], [0.8, 0.8, 0.8], 0.2,
            _ambient,
            [0.3, 0.6, 0.3], [85.0/255.0, 133.0/255.0, 174.0/255.0],
            //specular, shininess,
            [ 1.0, 1.0, 1.0], [ 1.0, 1.0, 1.0],
            [1.0, 1.0, 1.0], [0.5, 0.5, 0.5]
        ],
        // teximage
        [
            // light_direction, specular, shininess
            [0.7, 0.0, 0.7], [0.8, 0.8, 0.8], 0.2,
            _ambient,
            [1.0, 1.0, 1.0], [1.0, 1.0, 1.0],
            //specular, shininess,
            [0.0, 0.0, 0.0], [ 0.0, 0.0, 0.0],
            [0.0, 0.0, 0.0], [0.5, 0.5, 0.5]
        ],
        // cubemap
        [
            // light_direction, specular, shininess
            [0.7, 0.0, 0.7], [0.8, 0.8, 0.8], 0.2,
            _ambient,
            [1.0, 1.0, 1.0], [1.0, 1.0, 1.0],
            //specular, shininess,
            [0.0, 0.0, 0.0], [ 0.0, 0.0, 0.0],
            [0.0, 0.0, 0.0], [0.5, 0.5, 0.5]
        ]
    ];

// light_direction, specular, shininess
/*
  var light_data = [
  // default
  [[0.7, 0.0, 0.7], [0.8, 0.8, 0.8], 0.2],
  // teximage
  [[1.0, 0.0, 0.25], [0.2, 0.2, 0.2], 0.8],
  // cube
  [[0.0, 0.0, 1.0], [0.8, 0.8, 0.8], 0.5]
  ];
*/
//////////

Color = function(viewer) {
    "use strict";
    this.viewer = viewer;
    this.id = 0;
};

Color.prototype.set = function(id) {
    "use strict";
    this.id = id;
    // set color mode: color, teximage, cubemap, local
    var colormode = [0, 0, 0, 1, 2];
    var c = colormode[id];
    this.viewer.multishader.setColorMode(c);

    var data = _colors[id];
    // set light data
    this.viewer.multishader.set_light_data(data.slice(0,3));
    // set color data
    this.viewer.multishader.set_colors(data.slice(3,10));
};
