/*global
  document:false
  baseURL:false
  disableSelection:false
  _disabled:false
  _create_div:false
  _set_geometry:false
  _set_attributes:false
  surface_data:false
  CONFIG:false
  BUTTONBOX:false
  BUTTON:false
*/

var INFOBOX_COUNT = 6;
var _text_color = "rgba(0,0,0,1.0)";
//var _text_color = "rgba(20,20,20,1.0)";
//_text_color = "rgba(60,60,60,1.0)";

function _create_close_button(parent) {
    "use strict";

    //--------------------------------------------
    var x = document.createElement('img');
    parent.appendChild(x);

    x.style.position = 'absolute';
    //x.style.bottom = '0px';

    x.src = baseURL+'image/ex-dark.png';
    //x.style.fontSize = '40px';
    x.style.fontFamily = 'Verdana Arial, Helvetica, sans-serif';
    x.style.right = '0px';
    x.style.top = '0px';
    x.style.width = '40px';
    x.style.height = '40px';

    x.style.color = 'rgba(0, 0, 0, 0)';
    x.style.backgroundColor = 'rgba(0, 0, 0, 0)';

    var p = 12;
    x.style.padding = p + "px " + p + "px " + p + "px " + p + "px";

    _set_attributes(x);

    return x;
}

function make_html_image(url, width, height, float_right) {
    "use strict";
    var s = "<img ";
    if (float_right) {
        s += "style='float:right;' ";
    }
    s += "src='" + url + "' width='" + width + "' height='" + height + "'>";
    return s;
}


function finger_table() {
    "use strict";

    var finger_size = [
        [140, 180],
        [179, 180],
        [188, 180]
    ];

/*
    // === GERMAN ===
    var finger_text = [
        "&nbsp;&nbsp;&nbsp;&nbsp;Drehen",
        "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Verschieben | Zoomen | Rotieren",
        "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Transformieren"
    ];
*/

    // === ENGLISH ===
    var finger_text = [
        "&nbsp;&nbsp;&nbsp;&nbsp;Rotate in R<sup>3</sup>",
        "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Translate | Zoom | Spin<sup> </sup>",
        "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Rotate in S<sup>3</sup>"
    ];



/*
    var text_padding = [
        [20, 32],
        [20+30, 54-30],
        [20, 50]
    ];
*/
    var text_padding = [
        [0, 0],
        [0, 0],
        [0, 0]
    ];

    var s = 0.8;
    // margin-left:auto; margin-right:auto;
    var fingers="<table border='0' cellpadding='10' cellspacing='0' style='position:absolute; bottom:36px; left:188px; margin-bottom:18px;" + "color:" + _text_color + "; font-size:20px;'><tr>";
    for (var i = 0; i < finger_size.length; ++i) {
        var width = finger_size[i][0];
        var height = finger_size[i][1];

        var image = baseURL+'image/fingers/finger' + i + '-small.png';
        fingers += "<td style='text-align:center;" +
            "px; border-bottom:0; padding-bottom:10px;'>" +
            make_html_image( image , Math.round(s*width), Math.round(s*height)) + "</td>";
    }
    fingers += "</tr><tr>";
    for (var ix = 0; ix < finger_size.length; ++ix) {
        fingers += "<td style='color:rgba(60,60,60,1.0);padding-top: 12px; text-align:center; border-top:0;'>" + finger_text[ix] + "</td>";
    }
    
    fingers += "</tr></table>";

    return fingers;
}


Infobox = function(touchcontrols) {
    "use strict";
    this.visible = false;
    this.touchcontrols = touchcontrols;
    this._init();
};


Infobox.prototype._create_infobox = function(html, geometry, background_color, border_color) {
    "use strict";
    var x = _create_div(document.body, geometry);
    _set_attributes(x);

    _set_attributes(x);

    x.style.position = 'absolute';
    x.style.bottom = '0px';

    // color
    x.style.color = 'rgba(0, 0, 0, 1.0)';
    x.style.backgroundColor = background_color;

    // border
    x.style.borderStyle = "solid";
    x.style.borderWidth = "4px";
    x.style.borderColor = border_color;
    x.style.borderRadius = "20px";

    //x.style.textAlign = "justify";
    //x.style.textJustify = "inter-word";


    var p = 24;
    x.style.padding = p + "px " + p + "px " + p + "px " + p + "px";

    x.innerHTML = html;


    x.ontouchstart = function(event)
    {
        //event.preventDefault();
        return true;
    };
    // make invisible
    x.style.display = "none";

    var close_button = _create_close_button(x);

    function capture(this0) {
        return function(event) {
            this0.toggle();
            return false;
        };
    }

    var f = capture(this);

    if (CONFIG.touch) {
        close_button.ontouchstart = f;
    }
    if (CONFIG.mouse) {
        close_button.onclick = f;
    }

    return x;
};


Infobox.prototype._init = function() {
    "use strict";
    
    var head ="<head>"+
        "<style type=\"text/css\">"+
        "body {color:white; font-family: 'Share', sans-serif;}"+
        "h1 {font-size:64px; margin:0px 0px 0px 0px; padding:0px 0px 0px 0px; font-style: normal; font-weight: 400; font-family: 'Share', sans-serif; color:" + _text_color + ";}"+
        "h2 {font-size:24px; margin:0px 0px 0px 0px; padding:0px 0px 0px 0px; font-style: normal; font-weight: 400; font-family: 'Share', sans-serif; color:" + _text_color + ";}"+
        "p {font-size:32px; font-family: Share;color:" + _text_color + ";}"+
        "</style>"+
        "</head>";

    var fingers = finger_table();

    // infobox geometry (height is adjusted)
    var geometry = [300, 80, 900, 660];

    var credits="<div style='border-top-style:solid; border-color:rgba(60,60,60,1.0); border-width:1px; padding-top:12px; font-size:21px; display:block; position:absolute; bottom:12px; width:94.5%; text-align:center;'>GeometrieWerkstatt&nbsp;&nbsp;&nbsp;&#8212;&nbsp;&nbsp;Universit&auml;t T&uuml;bingen</div>";

    this.infobox = [];
    for (var i = 0; i < INFOBOX_COUNT; ++i) {
        var html = head +
            "<h1>" + surface_data[i].title + "</h1>" +
            "<h2 style='color:rgba(60, 60, 60, 1.0);'>" + surface_data[i].subtitle + "</h2>" +
            "<p>" + surface_data[i].description + "</p>" + fingers +
	    credits;
        geometry[3] = surface_data[i].infobox_height;
        this.infobox[i] = this._create_infobox(
            html, geometry,
            this.touchcontrols.background_color[0][1],
            this.touchcontrols.border_color);
    }

};

Infobox.prototype.hide_all = function() {
    "use strict";
    for (var i = 0; i < INFOBOX_COUNT; ++i) {
        this.infobox[i].style.display = "none";
    }
    this.visible = false;
};

Infobox.prototype.show = function(n) {
    "use strict";
    this.hide_all();
    this.infobox[n].style.display = "block";
    this.visible = true;
};

// set to a specified infobox
// useful when the infobox is visible while changing the surface
Infobox.prototype.set = function(n) {
    "use strict";
    if (this.visible) {
        // hide
        for (var i = 0; i < INFOBOX_COUNT; ++i) {
            this.infobox[i].style.display = "none";
        }
        // make visible
        this.infobox[n].style.display = "block";
    }
};

Infobox.prototype.toggle = function()
{
    "use strict";
    if (this.visible) {
        // hide
        this.hide_all();
        // set button off
        var box = this.touchcontrols.buttonbox[BUTTONBOX.shader];
        var button = box.button[BUTTON.info];
        button.set( false, false);
        button.counter = 1;
    }
    else {
        // show the infobox for the current surface
        var ix = this.touchcontrols.viewer.surfaceId;
        this.show(ix);
        // set button on
        var box1 = this.touchcontrols.buttonbox[BUTTONBOX.shader];
        var button1 = box1.button[BUTTON.info];
        button1.set( true, false);
        button1.counter = 0;
    }
};
