/*global
  xmat4:false
*/

XLAB.Mouse = function(animator, canvas) {
    "use strict";
    this.animator = animator;
    this.connect(canvas);
    this.p = null;
    this.button = null;
};

XLAB.Mouse.prototype._onMouseDown = function(event) {
    "use strict";

    // save button and position
    this.button = event.button;
    this.p = [event.clientX, event.clientY];

    // start
    switch (event.button) {
    case 0:
	this.animator.rotateR3_start(this.p);
	break;
    case 1:
	this.animator.translateXY_start(this.p);
	break;
    case 2:
	this.animator.rotateS3_start(this.p);
	break;
    }
};

XLAB.Mouse.prototype._onMouseMove = function(event) {
    "use strict";
    // NOTE: event.button is 0 for mouse move event

    // move
    var q = [event.clientX, event.clientY];
    switch (this.button) {
    case 0:
	this.animator.rotateR3_move(this.p, q);
	break;
    case 1:
	this.animator.translateXY_move(this.p, q);
	break;
    case 2:
	this.animator.rotateS3_move(this.p, q);
	break;
    }
    // save state
    this.p = q;
};

XLAB.Mouse.prototype._onMouseUp = function(event) {
    "use strict";

    if (this.button != event.button) { return; }

    switch (event.button) {
    case 0:
	this.animator.rotateR3_end();
	break;
    case 1:
	this.animator.translateXY_end();
	break;
    case 2:
	this.animator.rotateS3_end();
	break;
    }

    this.button = null;
};

XLAB.Mouse.prototype.connect = function(canvas) {
    "use strict";
    canvas.onmousedown =
        function(this0) {
            return function(event) { this0._onMouseDown(event); }; }(this);
    canvas.onmousemove =
        function(this0) {
            return function(event) { this0._onMouseMove(event); }; }(this);
    canvas.onmouseup =
        function(this0) {
            return function(event) {this0._onMouseUp(event); }; }(this);
};
