/*global
 console:false
*/

function _join(src) {
  "use strict";
  return (typeof src == 'string') ? src : src.join('');
}

/*
  Shader constructor
*/
XLAB.Shader = function(type) {
  "use strict";
  this.type = type;
};

/*
  Compiles this Shader.
*/
XLAB.Shader.prototype.compile = function(gl, src, url) {
    "use strict";
  if (this.shader) {
    gl.deleteShader(this.shader);
  }
  this.url = url;
  this.shader = gl.createShader(this.type);

  gl.shaderSource(this.shader, _join(src));
  gl.compileShader(this.shader);


  var t;
  switch (this.type) {
    case gl.VERTEX_SHADER:   t = "vertex";   break;
    case gl.FRAGMENT_SHADER: t = "fragment"; break;
  }

  // check error
  if ( ! gl.getShaderParameter(this.shader, gl.COMPILE_STATUS)) {
    throw "error in " + t + " shader url=" + url + "\n" + gl.getShaderInfoLog(this.shader);
  }
};
